diff --git a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 9df5b50f4..4ba3aaaf4 100644
--- a/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.BlockSand;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
@@ -235,7 +236,7 @@ public class ChunkDecoratorOverworld
             treeDensity += k4 + 5;
         }
         if (biome == Biomes.OVERWORLD_FOREST_DRY) {
-            treeDensity += k4;
+            treeDensity += k4 + 1;
         }
         if (biome == Biomes.OVERWORLD_BIRCH_FOREST) {
             treeDensity += k4 + 4;
@@ -258,8 +259,11 @@ public class ChunkDecoratorOverworld
         if (biome == Biomes.OVERWORLD_TUNDRA) {
             treeDensity -= 20;
         }
+        if (biome == Biomes.OVERWORLD_DESERT) {
+            treeDensity += k4;
+        }
         if (biome == Biomes.OVERWORLD_CAATINGA) {
-            treeDensity += k4 + 10;
+            treeDensity += k4 + 4;
         }
         if (biome == Biomes.OVERWORLD_SWAMPLAND) {
             treeDensity += k4 + 4;
@@ -268,12 +272,17 @@ public class ChunkDecoratorOverworld
             treeDensity += k4;
         }
         if (treeDensityOverride != -1) treeDensity = treeDensityOverride;
-        for (int i11 = 0; i11 < treeDensity; i11++) {
-            int l13 = x + rand.nextInt(16) + 8;
-            int j14 = z + rand.nextInt(16) + 8;
-            WorldFeature feature = biome.getRandomWorldGenForTrees(rand);
-            feature.func_517_a(1.0D, 1.0D, 1.0D);
-            feature.generate(world, rand, l13, world.getHeightValue(l13, j14), j14);
+        try {
+        	BlockLeavesBase.enableDecay = false;
+            for (int i11 = 0; i11 < treeDensity; i11++) {
+                int l13 = x + rand.nextInt(16) + 8;
+                int j14 = z + rand.nextInt(16) + 8;
+                WorldFeature feature = biome.getRandomWorldGenForTrees(rand);
+                feature.func_517_a(1.0D, 1.0D, 1.0D);
+                feature.generate(world, rand, l13, world.getHeightValue(l13, j14), j14);
+            }
+        }finally {
+        	BlockLeavesBase.enableDecay = true;
         }
         byte byteReeds = 0;
         if (biome == Biomes.OVERWORLD_RAINFOREST) {
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
index 317bc2c8e..5de93e4ce 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
+++ b/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
@@ -7,6 +7,9 @@ import java.util.Random;
 import java.util.Set;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockFlower;
+import net.minecraft.core.block.BlockLeavesBase;
+import net.minecraft.core.block.BlockLog;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
@@ -44,6 +47,8 @@ public class WorldFeatureTreePalm extends WorldFeature {
 	 */
 	protected float[] leafAnglesUpper;
 	
+	protected int logHeight;
+	
 	protected Set<Integer> intSet = new HashSet<>();
 	protected List<Integer> intList = new ArrayList<>();
 	
@@ -61,23 +66,23 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		this.basePos = new ChunkPosition(x, y, z);
 		
 		int blockBelow = world.getBlockId(x, y - 1, z);
-		if(!canGrowOnThisBlock(blockBelow)) {
+		if(!canGrowOnThisBlock(blockBelow) || !(blockBelow == Block.sand.id && waterNearby(x, y, z))) {
+			return false;
+		}
+		if(!generateTrunkIfPossible()) {
 			return false;
 		}
-		
-		// TODO Check if location is valid
 		
 		WorldFeatureTree.onTreeGrown(world, x, y, z);
 		
-		generateTrunk();
-		
 		calculateLeafAngles();
 		
 		generateLeaves();
 		return true;
 	}
 	
-	public void generateTrunk() {
+	public boolean generateTrunkIfPossible() {
+		// Setup values for trunk generation
 		int height;
 		if(big) {
 			height = 11 + random.nextInt(7);	
@@ -94,32 +99,112 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		}
 		Direction direction = Direction.horizontalDirections[random.nextInt(4)];
 		
-		generateTrunk(height, angle, bend, direction);
+		return generateTrunkIfPossible(height, angle, bend, direction);
 	}
 	
-	public void generateTrunk(int height, float angle, float bend, Direction direction) {
-		int x = basePos.x;
-		int y = basePos.y;
-		int z = basePos.z;
+	public boolean generateTrunkIfPossible(int height, float angle, float bend, Direction direction) {
+		intList.clear();
+		intSet.clear();
 		
+		// Generate all log block positions
 		for(int i=0; i < height; i++) {
-			y = basePos.y + i;
-			
 			float yFactor = i / (float) height;
 			int offset = MathHelper.floor_double(Math.pow(yFactor, angle + 1.0f) * bend);
 			
-			x = basePos.x + direction.getOffsetX() * offset;
-			z = basePos.z + direction.getOffsetZ() * offset;
+			int offsetX = direction.getOffsetX() * offset;
+			int offsetY = i;
+			int offsetZ = direction.getOffsetZ() * offset;
+			
+			intList.add(encode(offsetX, offsetY, offsetZ));
+		}
+		
+		// Check if any blocks are in the way
+		int lastPossibleBlockIndex = intList.size() - 1;
+		for(int i=0; i < intList.size(); i++) {
+			int offset = intList.get(i);
+			int x = basePos.x + decodeX(offset);
+			int y = basePos.y + decodeY(offset);
+			int z = basePos.z + decodeZ(offset);
+			
+			if(!isClear(x, y, z)) {
+				lastPossibleBlockIndex = i - 1;
+				break;
+			}
+		}
+		
+		for(int i = lastPossibleBlockIndex; i >= 0; i--) {
+			int offset = intList.get(i);
+			int x = basePos.x + decodeX(offset);
+			int y = basePos.y + decodeY(offset);
+			int z = basePos.z + decodeZ(offset);
+			
+			if(isClearRange(x, y, z, 2, 2, 2)) {
+				break;
+			}
+			lastPossibleBlockIndex = i - 1;
+		}
+		
+		int minHeight = Math.min(6, height - 2);
+		if(lastPossibleBlockIndex < minHeight) {
+			return false;
+		}
+
+		int x = 0;
+		int y = 0;
+		int z = 0;
+		logHeight = lastPossibleBlockIndex + 1;
+		for(int i=0; i < logHeight; i++) {
+			int offset = intList.get(i);
+			x = basePos.x + decodeX(offset);
+			y = basePos.y + decodeY(offset);
+			z = basePos.z + decodeZ(offset);
 			
 			generateBlock(x, y, z, log);
 		}
 		
 		this.endPos = new ChunkPosition(x, y, z);
+		
+		return true;
+	}
+	
+	public boolean isClear(int x, int y, int z) {
+		int id = world.getBlockId(x, y, z);
+		if(id == 0) {
+			return true;
+		}
+		Block block = Block.getBlock(id);
+		
+		// TODO Create BlockTag and apply to all trees
+		if(block instanceof BlockLog) {
+			return true;
+		}
+		if(block instanceof BlockLeavesBase) {
+			return true;
+		}
+		if(block instanceof BlockFlower) {
+			return true;
+		}
+		return false;
+	}
+	
+	public boolean isClearRange(int x, int y, int z, int w, int h, int d) {
+		for(int i = -w; i <= w; i++) {
+			for(int j = -h; j <= h; j++) {
+				for(int k = -d; k <= d; k++) {
+					int x1 = x + i;
+					int y1 = y + j;
+					int z1 = z + k;
+					if(!isClear(x1, y1, z1)) {
+						return false;
+					}
+				}
+			}
+		}
+		return true;
 	}
 	
 	public void calculateLeafAngles() {
-		//int leafCount = random.nextInt(2) + 4;
-		int leafCount = 5;
+		int leafCount = 6;
 		float baseAngle = 360.0f / leafCount;
 		float offset = random.nextFloat() * baseAngle;
 		
@@ -146,7 +231,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 	}
 	
 	public void generateLeaves() {
-		float leafLength = big ? 5.0f : 4.0f;
+		float leafLength = logHeight >= 10 ? 5.0f : 4.0f;
 		
 		for(int i=0; i < leafAngles.length; i++) {
 			float angle = leafAngles[i];
@@ -222,6 +307,19 @@ public class WorldFeatureTreePalm extends WorldFeature {
 			}
 		}
 	}
+
+	private boolean waterNearby(int x, int y, int z){
+		int distance = 1;
+		for(int xi = x - distance; xi< x + distance; xi++){
+			for(int zi = z - distance; zi< z + distance; zi++){
+				Block blockAtRange = world.getBlock(xi, y-1, zi);
+				if(blockAtRange != null && blockAtRange.hasTag(BlockTags.IS_WATER)){
+					return true;
+				}
+			}
+		}
+		return false;
+	}
 	
 	public void generateBlock(int x, int y, int z, Block block) {
 		if(update) {
@@ -232,7 +330,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 	}
 	
 	public boolean canGrowOnThisBlock(int id) {
-		return Block.hasTag(id, BlockTags.GROWS_TREES) || id == Block.sand.id;
+		return Block.hasTag(id, BlockTags.GROWS_TREES);
 	}
 	
 	public static int encode(int x, int y, int z) {
diff --git a/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java b/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java
index d2ecf7cba..a4380a8b1 100644
--- a/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java
+++ b/src/main/java/net/minecraft/core/world/season/SeasonManagerCycle.java
@@ -32,7 +32,7 @@ public final class SeasonManagerCycle
         return config;
     }
 
-    private int getSeasonLengthTicks(Season season)
+    public int getSeasonLengthTicks(Season season)
     {
         return config.getSeasonLength(season) * Global.DAY_LENGTH_TICKS;
     }
